package testapp;

import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.RemoveException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.apache.log4j.Logger;


/**
 *
 * @ejb.bean name="Test" jndi-name="app/default/Test"
 *           type="Stateless" view-type="both"
 *
 * @ejb.ejb-ref ejb-name="Ejb2Test"
 *             view-type="local"
 *             ref-name="ejb/Ejb2TestLocal"
 *             
 * @ejb.home remote-package="testapp"
 * @ejb.interface remote-package="testapp"
 * @ejb.util generate="logical"
 * @ejb.permission role-name="execApplRgt,asyncActRgt"
 * @stereotype bean class
 */
public class TestBean implements SessionBean {

    private static final long serialVersionUID = 1L;

    public void ejbActivate() throws EJBException, RemoteException {
    }

    public void ejbPassivate() throws EJBException, RemoteException {
    }

    /**
     * Create the bean.
     *
     * @ejb.create-method
     */
    public void ejbCreate() {
    }
    
    public void ejbRemove() throws EJBException, RemoteException {
    }

    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }

    /**
     * @ejb.interface-method
     */
    public String test(String message) {
        Logger logger = Logger.getLogger(TestBean.class);
        
        try {
            InitialContext ctx = new InitialContext();
            Object obj = ctx.lookup("ConnectionFactory");
            ConnectionFactory tcf = (ConnectionFactory) obj;
            Connection tc = tcf.createConnection("user", "password");
            
            Ejb2TestLocalHome lHome = Ejb2TestUtil.getLocalHome();
            Ejb2TestLocal local = lHome.create();
            message = local.test2(message);
            local.remove();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        logger.info("This is the test bean: " + message);
        return "This comes from the test bean: " + message;
    }
}

